#include <stdio.h>
#include <stdlib.h>

//definicion de estructuras necesarias
typedef struct node1 {
    int data;
    struct node1 *next;
    } Node;

typedef struct {
    int total;
    Node *next;
    } Head;

//declaracion de funciones utilizadas
Node* crea_nodo();
void agrega_info(Node*);
void agrega_nodo_principio(Node*, Head*);
void agrega_nodo_final(Node*, Head*);
void imprime_lista(Node*);
void borra_todos(Head*);


/*    Funcuines   */

//Asigna memoria a un elemnto tipo nodo
Node* crea_nodo(){
    Node* p;
    p=(Node*)malloc(sizeof(Node));
    return p;
}
//Agrega nodo al principio de la lista
void agrega_nodo_principio(Node* n, Head* h){
	n->next=h->next;
	h->next=n;
	h->total++;
    printf("\n Agregar al principio %d", n->data);

}

//Agrega un nodo al final de la lista
void agrega_nodo(Node *n, Head *h){
	Node* ptr,*ptrx;
	ptr=h->next;
	if(ptr==NULL||(n->data<h->next->data))
		agrega_nodo_principio(n,h);
	else{
		while(n->data>=ptr->data&&ptr!=NULL){
			ptrx=ptr;
			ptr=ptr->next;
		}
		n->next=ptr;
		ptrx->next=n;
			h->total++;
			}
	printf("\n agregar %d", n->data);

}

void agrega_nodo_final(Node* n, Head* h){
  Node* ptr;
  ptr=h->next;
  if(ptr==NULL) agrega_nodo_principio(n,h);
  else{
		  while(ptr->next != NULL) ptr=ptr->next;
		  ptr->next=n;
		  n->next=NULL;
		  h->total++;
		  printf("\n agregar al final %d", n->data);
		}
}
void agrega_info(Node* n){
  n->data=rand()%10+1;
  n->next=NULL;
}
void imprime_lista(Node* ptr){
	printf("\n");
	while(ptr != NULL){
	  printf(" %d", ptr->data);
	  ptr=ptr->next;
	}
}

void borra_todos(Head* h){
Node *ptr, *ptrx;
	ptr=h->next;
	while(ptr != NULL) {
		printf("\n Borrando nodo con dato  %d", ptr->data);
		ptrx=ptr;
		ptr=ptr->next;
		free(ptrx);
		h->next=ptr;
		h->total--;
	}
}
int main(void){
    Node *ptr, *ptrx;
    Head h;
    int ix;
    h.total=0;
    h.next=NULL;
    for(ix=0;ix<20; ix++){
		ptr=crea_nodo();
		agrega_info(ptr);
		agrega_nodo_principio(ptr,&h);
		//agrega_nodo(ptr, &h);
		imprime_lista(h.next);

    }
    printf("\n Hay %d nodos en la lista ligada", h.total);
    imprime_lista(h.next);

    borra_todos(&h);

    printf("\n La lista ligada tiene  %d elementos ", h.total);
    printf("\n FIN \n");

getchar();
return 0;

}


